package controlador;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.sql.ResultSet;
import java.sql.SQLException;

import modelo.Modelo_Login;
import vista.swing.Vista_Login;
import entidad.Login;

public class Controlador_Login implements ActionListener, KeyListener,
        FocusListener {

    private Vista_Login vista;
    private Modelo_Login modelo;
    private Login entidad = new Login();

    public Controlador_Login(Vista_Login vista, Modelo_Login modelo) {
        this.vista = vista;
        this.modelo = modelo;
    }

    @Override
    public void actionPerformed(ActionEvent evt) {
        if (evt.getActionCommand().equals("aceptar")) {
            if (vista.getTxtUsuario().equals("")
                    && !vista.getTxtContrasena().equals("")) {
                vista.mostrarCampoFaltante01();
                vista.setErrorFrame();
                vista.desactivarBtnAceptar();
            } else if (!vista.getTxtUsuario().equals("")
                    && vista.getTxtContrasena().equals("")) {
                vista.mostrarCampoFaltante02();
                vista.setErrorFrame();
                vista.desactivarBtnAceptar();
            } else if (vista.getTxtUsuario().equals("")
                    && vista.getTxtContrasena().equals("")) {
                vista.mostrarCampoFaltante01();
                vista.mostrarCampoFaltante02();
                vista.setErrorFrame();
                vista.desactivarBtnAceptar();
            } else {
                ResultSet resultado = modelo.verificarLogeo(
                        vista.getTxtUsuario(), vista.getTxtContrasena(), this);
                if (resultado != null) {
                    try {
                        resultado.first();
                        entidad.setCodigoUsuario(resultado.getString(1));
                        entidad.setNivelUsuario(resultado.getString(2));
                        entidad.setUsername(resultado.getString(3));
                        entidad.setContrasena(resultado.getString(4));
                        vista.setLimpiadorErrorDescTxt();
                        vista.setTamFrameInicial();
                    } catch (SQLException sqlEx) {
                        String error = "Los datos ingresados no se encuentran registrados en el sistema. ERROR: "
                                + sqlEx.toString();
                        manejarError(error);
                    } catch (Exception ex) {
                        String error = "Error inesperado en la realización de la operación de ingreso. ERROR: "
                                + ex.toString();
                        manejarError(error);
                    }
                }
            }
        } else if (evt.getActionCommand().equals("cancelar")) {
            vista.detenerAplicacion();
        }
    }

    @Override
    public void focusGained(FocusEvent evt) {
        if (vista.getTxtUsuario().equals("Nombre de usuario")
                && vista.getTxtContrasena().equals("contrasena1234567")) {
            vista.setLimpiadorCamposTxt();
            vista.activarBtnAceptar();
        }
    }

    @Override
    public void focusLost(FocusEvent evt) {
    }

    @Override
    public void keyPressed(KeyEvent evt) {
    }

    @Override
    public void keyReleased(KeyEvent evt) {
        if (vista.getTxtUsuario().length() > 0) {
            vista.ocultarCampoFaltante01();
        }
        if (vista.getTxtContrasena().length() > 0) {
            vista.ocultarCampoFaltante02();
        }
        if (vista.getTxtUsuario().length() > 0
                && vista.getTxtContrasena().length() > 0) {
            vista.setLimpiadorErrorDescTxt();
            vista.setTamFrameInicial();
            vista.activarBtnAceptar();
        }
        if (evt.getKeyCode() == KeyEvent.VK_BACK_SPACE
                && vista.getTxtUsuario().length() == 0) {
            vista.mostrarCampoFaltante01();
            vista.setLimpiadorErrorDescTxt();
            vista.setErrorCapturado("FALTAN CAMPOS REQUERIDOS ('*')");
            vista.setErrorFrame();
            vista.desactivarBtnAceptar();
        }
        if (evt.getKeyCode() == KeyEvent.VK_BACK_SPACE
                && vista.getTxtContrasena().length() == 0) {
            vista.mostrarCampoFaltante02();
            vista.setLimpiadorErrorDescTxt();
            vista.setErrorCapturado("FALTAN CAMPOS REQUERIDOS ('*')");
            vista.setErrorFrame();
            vista.desactivarBtnAceptar();
        }
    }

    @Override
    public void keyTyped(KeyEvent evt) {
        if (vista.getCantContrasena() == vista.getCantCaracteres()) {
            evt.consume();
        }
    }

    public void manejarError(String error) {
        vista.setLimpiadorErrorDescTxt();
        vista.setErrorCapturado(error);
        vista.setErrorFrame();
    }
}