package gui_control;

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

@SuppressWarnings("serial")
public class JTextField_LimitadorLetras extends PlainDocument {

    private JTextField txtRecibido;
    private int numMaxCaracteres;

    public JTextField_LimitadorLetras(JTextField txtRecibido,
            int numMaxCaracteres) {

        this.txtRecibido = txtRecibido;
        this.numMaxCaracteres = numMaxCaracteres;

    }

    @Override
    public void insertString(int txtLongitud, String txtIntroducido,
            AttributeSet txtAtributos) throws BadLocationException {
        for (int i = 0; i < txtIntroducido.length(); i++) {
            if ((txtRecibido.getText().length() + txtIntroducido.length()) > numMaxCaracteres) {
                txtRecibido.transferFocus();
                return;
            } else if (!Character.isLetter(txtIntroducido.charAt(i))
                    && !Character.isSpaceChar(txtIntroducido.charAt(i))
                    && txtIntroducido.compareTo(".") != 0)
                return;
        }
        super.insertString(txtLongitud, txtIntroducido, txtAtributos);
    }
}