package modelo;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import controlador.Controlador_Login;

public class Modelo_Login {

    public ResultSet verificarLogeo(String username, String password,
            Controlador_Login controlador) {

        Connection cnx = DAO.obtenerConeccion();
        PreparedStatement queryDB = null;
        String select = "SELECT codigo, nivel, nombre_usuario, contrasena FROM login WHERE nombre_usuario = ? AND contrasena = ?";

        try {
            queryDB = cnx.prepareStatement(select);

            queryDB.setString(1, username);
            queryDB.setString(2, password);

            ResultSet resultadoConsulta = queryDB.executeQuery();
            return resultadoConsulta;
        } catch (SQLException sqlEx) {
            String error = "Error de MySQL al tratar de establecer la conexión con la tabla correspondiente. ERROR: "
                    + sqlEx.toString();
            controlador.manejarError(error);
        } catch (NullPointerException npEx) {
            String error = "Error de envío de datos hacia la tabla correspondiente; la conexión NO se ha podido establecer. ERROR: "
                    + npEx.toString();
            controlador.manejarError(error);
        } catch (Exception ex) {
            String error = "Error inesperado en la realización de la operación. ERROR: "
                    + ex.toString();
            controlador.manejarError(error);
        }
        return null;
    }
}