package vista.swing;

import gui_control.JPanel_Degradado;
import gui_control.JTextField_LimitadorLetras;

import java.awt.Color;
import java.awt.Font;

import javax.swing.BoundedRangeModel;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollBar;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

import controlador.Controlador_Login;

@SuppressWarnings("serial")
public class Vista_Login extends JFrame {

    private JLabel lblBienvenido = new JLabel();
    private JLabel lblIngresaDatos = new JLabel();
    private JLabel lblUsername = new JLabel();
    private JLabel lblContrasena = new JLabel();
    private JLabel lblError01 = new JLabel();
    private JLabel lblError02 = new JLabel();
    private JTextField txtUsername = new JTextField();
    private JTextField txtErrorDesc = new JTextField();
    private JPasswordField ptxtContrasena = new JPasswordField();
    private JButton btnAceptar = new JButton();
    private JButton btnCancelar = new JButton();
    private JScrollBar scrBError = new JScrollBar(JScrollBar.HORIZONTAL);
    private JPanel pnlPrincipal = new JPanel();
    private JPanel pnlLogin = new JPanel();
    private JPanel pnlErrorException = new JPanel();
    private JPanel_Degradado pnlSuperior = new JPanel_Degradado();
    private LineBorder brdPanel = new LineBorder(Color.LIGHT_GRAY, 1, true);
    private BoxLayout boxLy = new BoxLayout(pnlErrorException, BoxLayout.Y_AXIS);
    private Color clrBackground = new Color(150, 0, 0);
    private Color clrSuperior = new Color(50, 0, 0);
    private Color clrInferior = new Color(150, 0, 0);
    private Color clrTxtBackground = new Color(255, 204, 102);
    private Font fntBienvenido = new Font("Verdana", Font.BOLD, 14);
    private Font fntGeneral = new Font("Tahoma", Font.PLAIN, 11);
    private Font fntError = new Font("Tahoma", Font.BOLD, 15);
    private Font fntBoton = new Font("Verdana", Font.BOLD, 12);
    private String error = "FALTAN CAMPOS REQUERIDOS ('*')";
    private int limiteCaracteres = 17;
    private BoundedRangeModel brm = null;

    public Vista_Login() {

        pnlPrincipal.setLayout(null);
        pnlPrincipal.setBackground(clrBackground);

        pnlSuperior.setLayout(null);
        pnlSuperior.setColorSuperior(clrSuperior);
        pnlSuperior.setColorInferior(clrInferior);

        pnlLogin.setLayout(null);
        pnlLogin.setBorder(brdPanel);
        pnlLogin.setBackground(clrSuperior);
        pnlLogin.setBounds(21, 71, 335, 73);

        lblBienvenido.setText("Bienvenido");
        lblIngresaDatos
                .setText("Ingresa tus datos para acceder a la aplicación :");
        lblUsername.setText("Nombre de usuario :");
        lblContrasena.setText("Contraseña :");
        lblError01.setText("*");
        lblError02.setText("*");

        lblBienvenido.setFont(fntBienvenido);
        lblBienvenido.setForeground(Color.LIGHT_GRAY);
        lblBienvenido.setBounds(21, 22, 100, 14);
        lblIngresaDatos.setFont(fntGeneral);
        lblIngresaDatos.setForeground(Color.WHITE);
        lblIngresaDatos.setBounds(21, 39, 243, 14);
        lblUsername.setForeground(Color.WHITE);
        lblUsername.setBounds(27, 14, 115, 14);
        lblContrasena.setHorizontalAlignment(JLabel.RIGHT);
        lblContrasena.setForeground(Color.WHITE);
        lblContrasena.setBounds(26, 45, 115, 14);
        lblError01.setFont(fntError);
        lblError01.setForeground(Color.RED);
        lblError01.setBounds(312, 14, 13, 14);
        lblError02.setFont(fntError);
        lblError02.setForeground(Color.RED);
        lblError02.setBounds(312, 45, 13, 14);

        txtUsername.setBackground(clrTxtBackground);
        txtUsername
                .setDocument(new JTextField_LimitadorLetras(txtUsername, 17));
        txtUsername.setBounds(152, 11, 150, 20);
        ptxtContrasena.setBackground(clrTxtBackground);
        ptxtContrasena.setBounds(152, 42, 150, 20);

        btnAceptar.setText("ACEPTAR");
        btnCancelar.setText("CANCELAR");

        btnAceptar.setFont(fntBoton);
        btnAceptar.setBackground(Color.BLACK);
        btnAceptar.setForeground(Color.WHITE);
        btnAceptar.setActionCommand("aceptar");
        btnAceptar.setBounds(241, 162, 115, 35);
        btnCancelar.setFont(fntBoton);
        btnCancelar.setBackground(Color.BLACK);
        btnCancelar.setForeground(Color.WHITE);
        btnCancelar.setActionCommand("cancelar");
        btnCancelar.setBounds(111, 162, 115, 35);

        txtErrorDesc.setBackground(clrTxtBackground);
        txtErrorDesc.setForeground(Color.RED);
        txtErrorDesc.setFont(fntBoton);

        brm = txtErrorDesc.getHorizontalVisibility();
        scrBError.setModel(brm);

        pnlSuperior.add(lblBienvenido);
        pnlSuperior.add(lblIngresaDatos);
        pnlSuperior.setBounds(0, 0, 377, 130);

        pnlLogin.add(lblUsername);
        pnlLogin.add(txtUsername);
        pnlLogin.add(lblError01);
        pnlLogin.add(lblContrasena);
        pnlLogin.add(ptxtContrasena);
        pnlLogin.add(lblError02);

        pnlErrorException.setVisible(false);
        pnlErrorException.setLayout(boxLy);
        pnlErrorException.add(txtErrorDesc);
        pnlErrorException.add(scrBError);
        pnlErrorException.setBounds(21, 217, 335, 40);

        pnlPrincipal.add(pnlLogin);
        pnlPrincipal.add(pnlSuperior);
        pnlPrincipal.add(btnAceptar);
        pnlPrincipal.add(btnCancelar);
        pnlPrincipal.add(pnlErrorException);
        getContentPane().add(pnlPrincipal);
    }

    public void activarBtnAceptar() {
        btnAceptar.setEnabled(true);
    }

    public void arrancarAplicacion() {
        this.pack();
        setTamFrameInicial();
        this.setTitle("LOGIN");
        this.setResizable(false);
        this.setLocationRelativeTo(null);
        inicializarControles();
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setVisible(true);
    }

    public void desactivarBtnAceptar() {
        btnAceptar.setEnabled(false);
    }

    public void detenerAplicacion() {
        System.exit(0);
    }

    public int getCantCaracteres() {
        return limiteCaracteres;
    }

    public int getCantContrasena() {
        int totalCaracteres = ptxtContrasena.getPassword().length;
        return totalCaracteres;
    }

    public String getErrorCapturado() {
        return error;
    }

    public JLabel getLblError01() {
        return lblError01;
    }

    public JLabel getLblError02() {
        return lblError02;
    }

    public String getTxtContrasena() {
        char pass[] = ptxtContrasena.getPassword();
        String password = "";

        for (char pas : pass) {
            password = password + pas;
        }

        return password;
    }

    public String getTxtUsuario() {
        return txtUsername.getText();
    }

    private void inicializarControles() {
        setTxtCamposDefault();
        ocultarCampoFaltante01();
        ocultarCampoFaltante02();
        desactivarBtnAceptar();
        txtErrorDesc.setEditable(false);
        scrBError.setEnabled(false);
        scrBError.requestFocusInWindow();
    }

    public void mostrarCampoFaltante01() {
        lblError01.setVisible(true);
    }

    public void mostrarCampoFaltante02() {
        lblError02.setVisible(true);
    }

    public void ocultarCampoFaltante01() {
        lblError01.setVisible(false);
    }

    public void ocultarCampoFaltante02() {
        lblError02.setVisible(false);
    }

    public void setControlador(Controlador_Login controlador) {
        txtUsername.addFocusListener(controlador);
        ptxtContrasena.addFocusListener(controlador);
        txtUsername.addKeyListener(controlador);
        ptxtContrasena.addKeyListener(controlador);
        btnAceptar.addActionListener(controlador);
        btnCancelar.addActionListener(controlador);
    }

    public void setErrorCapturado(String error) {
        this.error = error;
    }

    public void setErrorFrame() {
        this.setSize(383, 305);
        txtErrorDesc.setText(getErrorCapturado());
        scrBError.setEnabled(true);
        pnlErrorException.setVisible(true);
    }

    public void setLimpiadorCamposTxt() {
        txtUsername.setText("");
        ptxtContrasena.setText("");
    }

    public void setLimpiadorErrorDescTxt() {
        txtErrorDesc.setText("");
    }

    public void setTamFrameInicial() {
        pnlErrorException.setVisible(false);
        this.setSize(383, 245);
    }

    public void setTxtCamposDefault() {
        txtUsername.setText("Nombre de usuario");
        ptxtContrasena.setText("contrasena1234567");
    }
}